import paho.mqtt.client as mqtt
import json

device = "esp32_807A98"
broker_addr = "mqtt.lab"
broker_port = 1883
src = "mysrc"

def on_connect(client, userdata, flags, rc):
    print("Connected with result code "+str(rc))

def on_subscribe(client, userdata, mid, granted_qos):
    print("subscribed: " + str(mid) + ", with qos: " + str(granted_qos))
    msg = {
        "src": src,
        "id": 456,
        "method": "Sys.GetInfo"
    }
    client.publish(device+"/rpc", json.dumps(msg), 1, False)

def on_publish(client, userdata, mid):
    print("published "+str(mid))

def on_message(client, userdata, message):
    msg = json.loads(message.payload.decode("utf-8"))
    if msg["id"] == 456:
        print("System info:\n\t" + json.dumps(msg["result"]) + "\n")

client = mqtt.Client()
client.on_connect = on_connect
client.on_message = on_message
client.on_subscribe = on_subscribe
client.on_publish = on_publish

client.connect(broker_addr, broker_port)
client.subscribe(src+"/rpc", 1)

# Other loop*() functions are available that give a threaded interface and a
# manual interface.
client.loop_forever()
	
